{%macro exlusive(flags) %}
{%if flags|length>0 %}
{%for flag in flags%}
has_character_flag = {{flag}}
{%endfor%}
{%endif%}
{%endmacro%}
{%macro not_excusive(flags) %}
{%if flags|length>0 %}
NOT = {
    {{exlusive(flags)}}
}
{%endif%}
{%endmacro%}
{%macro if_exists(thing) %}
{%if thing is not none %}{{thing}}{%endif%}
{%endmacro%}
{% if not menu.is_submenu %}
decisions = {
{%endif%}
    {{menu.open}} = {
        potential = { 
            ai = no is_ruler = yes 
            NOT = { has_character_flag = {{menu.flag}}}
            {{if_exists(menu.default_potential)}}
            } 
        effect = { set_character_flag = {{menu.flag}} }
        revoke_allowed = { always = no}
        ai_will_do = { factor = 0}
        }
    {{menu.close}} = {
        potential = { 
            ai = no is_ruler = yes 
            has_character_flag = {{menu.flag}}
            {{if_exists(menu.default_potential)}}
            }
        effect = { clr_character_flag = {{menu.flag}}}
        revoke_allowed = { always = no}
        ai_will_do = { factor = 0}
        }
    {% for toggle in menu.get_toggles() %}
    {{toggle.on}} = {
        potential = { 
            ai = no 
            is_ruler = yes 
            has_character_flag = {{menu.flag}}
            NOT = { has_character_flag = {{toggle.flag}} }
            {{if_exists(menu._potentials[toggle.name])}}
            {{not_excusive(menu.get_exclusive_flags(toggle.name))}}}
        effect = { 
            set_character_flag = {{toggle.flag}}
            {{if_exists(menu._on_actions[toggle.name])}}}
        revoke_allowed = { always = no}
        ai_will_do = { factor = 0}
        }
    {{toggle.off}} = {
        potential = { 
            ai = no 
            is_ruler = yes 
            has_character_flag = {{menu.flag}}
            has_character_flag = {{toggle.flag}}
            {{if_exists(menu._potentials[toggle.name])}}}
        effect = { 
            clr_character_flag = {{toggle.flag}}
            {{if_exists(menu._off_actions[toggle.name])}}}
        revoke_allowed = { always = no}
        ai_will_do = { factor = 0}
        }
    {% endfor %}
    {% for option in menu.options %}
    {{option}} = {
        potential = { 
            ai = no 
            is_ruler = yes 
            has_character_flag = {{menu.flag}}
            {{if_exists(menu._potentials[option])}}
            {{exlusive(menu.get_exclusive_flags(option))}}}
        effect = { 
            {{if_exists(menu._on_actions[option])}}
            {{if_exists(menu._off_actions[option])}}}
        revoke_allowed = { always = no}
        ai_will_do = { factor = 0}
        }
    {% endfor %}
{% for subm in menu._submenus.values() %}
{{subm.render()}}
{%endfor%}
{% if not menu.is_submenu %}}{%endif%}